## nextepc 0.3.10%2Bnods

=== lib/freeDiameter-1.2.1/extensions/CMakeLists.txt ===
PROJECT("freeDiameter extensions" C)

# We want all resulting objects in the same folder
SET(LIBRARY_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})

# Use the macro FD_ADD_EXTENSION(name files...) to create an extension
# It is equivalent to add_library with the appropriate parameters
# and naming conventions (.fdx : FreeDiameter eXtension)
MACRO(FD_ADD_EXTENSION EXTNAME)
  ADD_LIBRARY(${EXTNAME} MODULE ${ARGN})
  SET_TARGET_PROPERTIES(${EXTNAME} PROPERTIES PREFIX "" )
  SET_TARGET_PROPERTIES(${EXTNAME} PROPERTIES SUFFIX ".fdx" )
ENDMACRO(FD_ADD_EXTENSION)

# Use the macro FD_EXTENSION_SUBDIR(extmacroname subdir descr default) to 
# add a new extension subdirectory.
MACRO(FD_EXTENSION_SUBDIR EXTSUBDIR EXTDESCR EXTDEFAULT)
   STRING(TOUPPER ${EXTSUBDIR} EXTMACRONAME)
   IF (NOT ALL_EXTENSIONS)
     OPTION(BUILD_${EXTMACRONAME} "Build ${EXTSUBDIR}.fdx? (${EXTDESCR})" ${EXTDEFAULT})
   ENDIF (NOT ALL_EXTENSIONS)
   IF (BUILD_${EXTMACRONAME} OR ALL_EXTENSIONS)
      SUBDIRS(${EXTSUBDIR})
   ENDIF (BUILD_${EXTMACRONAME} OR ALL_EXTENSIONS)
ENDMACRO(FD_EXTENSION_SUBDIR)

OPTION(ALL_EXTENSIONS "Build ALL available extensions? (disable to select individual components)" OFF)

# The extensions include the headers of freeDiameter that contains gnutls objects
INCLUDE_DIRECTORIES(${LFDCORE_INCLUDES})


###########################
# Extensions section

####
# Diameter applications dictionaries

FD_EXTENSION_SUBDIR(dict_nasreq "NASREQ (RFC4005) Dictionary definitions"       ON)
FD_EXTENSION_SUBDIR(dict_eap    "Diameter EAP (RFC4072) Dictionary definitions" ON)

FD_EXTENSION_SUBDIR(dict_dcca   "Diameter CC (RFC4006) Dictionary definitions [incomplete]" ON)
FD_EXTENSION_SUBDIR(dict_dcca_3gpp   "Diameter CC 3GPP Dictionary definitions [incomplete]" ON)
FD_EXTENSION_SUBDIR(dict_dcca_starent   "Diameter CC Starent Dictionary definitions" ON)

FD_EXTENSION_SUBDIR(dict_sip    "Diameter SIP (RFC4740) Dictionary definitions" ON)

FD_EXTENSION_SUBDIR(dict_mip6a     "Diameter Mobile IPv6 Auth Dictionary definitions"         ON)
FD_EXTENSION_SUBDIR(dict_mip6i     "Diameter Mobile IPv6 IKE Dictionary definitions"          ON)
FD_EXTENSION_SUBDIR(dict_nas_mipv6 "Diameter NAS-to-HAAA Interaction Dictionary definitions"  ON)
FD_EXTENSION_SUBDIR(dict_rfc5777   "Classification and QoS (RFC 5777) Dictionary definitions" ON)

FD_EXTENSION_SUBDIR(dict_legacy_xml "Load Diameter dictionary definitions from XML files."    OFF)


####
# Diameter applications

FD_EXTENSION_SUBDIR(app_acct    "Simple accounting application that stores accounting records in flat database" OFF)
FD_EXTENSION_SUBDIR(app_diameap "Diameter EAP Application server (RFC 4072)" 					OFF)
FD_EXTENSION_SUBDIR(app_radgw   "RADIUS/Diameter gateway translation - RADIUS client to Diameter server" 	OFF)
FD_EXTENSION_SUBDIR(app_sip     "Diameter SIP Authentication and Authorization server (RFC 4740)" 		OFF)

FD_EXTENSION_SUBDIR(app_redirect "Diameter Redirect server: send configurable Redirect indications to other peers" OFF)


####
# Routing extensions

FD_EXTENSION_SUBDIR(rt_busypeers "Handling of Diameter TOO_BUSY messages and relay timeouts"	ON)
FD_EXTENSION_SUBDIR(rt_default   "Configurable routing rules for freeDiameter" 		     	ON)
FD_EXTENSION_SUBDIR(rt_ereg      "Configurable routing based on regexp matching of AVP values" OFF)
FD_EXTENSION_SUBDIR(rt_ignore_dh "Stow Destination-Host in Proxy-Info, restore to Origin-Host for answers"	ON)
FD_EXTENSION_SUBDIR(rt_load_balance "Balance load over multiple equal hosts, based on outstanding requests"	ON)
FD_EXTENSION_SUBDIR(rt_randomize "Randomly choose one of the highest scored hosts and increase its score by one"	ON)
FD_EXTENSION_SUBDIR(rt_redirect  "Handling of Diameter Redirect messages" 			ON)


####
# Peers security extensions

FD_EXTENSION_SUBDIR(acl_wl "White-list based authorization of incoming connections" ON)


####
# Debug & test extensions

FD_EXTENSION_SUBDIR(dbg_monitor "Outputs periodical status information"              ON)
FD_EXTENSION_SUBDIR(dbg_msg_timings "Show some timing information for messages"      ON)
FD_EXTENSION_SUBDIR(dbg_msg_dumps "Show human-readable content of the received & sent messages"      ON)
FD_EXTENSION_SUBDIR(dbg_rt      "Routing extension for debugging the routing module" ON)
FD_EXTENSION_SUBDIR(test_app    "Testing application to send dummy message to another peer, like a Diameter 'ping'" OFF)
FD_EXTENSION_SUBDIR(test_sip    "Testing application to simulate Diameter-SIP client (RFC4740)" OFF)
FD_EXTENSION_SUBDIR(dbg_interactive "Python-interpreter based module"                OFF)
FD_EXTENSION_SUBDIR(test_netemul "Simple Diameter network emulator proxy extension (latency, PDV, duplicates)" OFF)



# The following extension have very little use except for specific tests, so we disable them except in Debug configurations.
IF (CMAKE_BUILD_TYPE MATCHES "Debug")
	FD_EXTENSION_SUBDIR(_sample     "Simple extension to demonstrate extension mechanism, for developpers" OFF)
	FD_EXTENSION_SUBDIR(test_acct   "Receive Accounting-Requests and display the data, but no storage" OFF)
	FD_EXTENSION_SUBDIR(test_rt_any "Routing extension randomly sending message to any peer available, for testing purpose" OFF)
ENDIF (CMAKE_BUILD_TYPE MATCHES "Debug")

=== debian/changelog ===
nextepc (0.3.10+nods-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add autopkgtest fix from Steve Langasek. (Closes: #935538)

 -- Adrian Bunk <bunk@debian.org>  Sat, 06 Feb 2021 18:02:21 +0200

nextepc (0.3.10+nods-4) unstable; urgency=low

  * d/patches/0007-Patch-deprecated-sys-sysctl.h-problem.patch
    - Fix FTBFS with GCC 10 (Closes: #954512)
  * Standards-Version: 4.5.1
  * debhelper-compat 13
  * d/rules: Disable tests for now
  * Add salsa-ci file
  * d/control:
    - Rules-Requires-Root: no
    - Use secure URI in Homepage field.
  * d/watch: Update watch file format version to 4.
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 23 Jan 2021 23:35:09 +0100

nextepc (0.3.10+nods-3) unstable; urgency=medium

  * debian/control:
    - Move mongodb to Recommends (Closes: #919093)
    - Move nextepc-pcrf and nextepc-hss from Recommends to Depends in the
      metapackage nextepc.
    - New standards version 4.3.0 - no changes

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 19 Jan 2019 09:12:13 +0100

nextepc (0.3.10+nods-2) unstable; urgency=medium

  * debian/patches/0006-Fix-big-endian-bug.patch:
    - Fix syntax error within WORDS_BIGENDIAN ifdef
  * debian/control:
    - Move some of the recommends back to dependencies for the binary package
      "nextepc".
  * debian/man/*:
    - Remove wrong information from man pages
    - Move man pages to section 8
  * debian/tests/*:
    - Implement autopkgtests checking that some executables can run

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 27 Nov 2018 19:31:51 +0100

nextepc (0.3.10+nods-1) unstable; urgency=medium

  * Add back excluded bundling of lib/freeDiameter-1.2.1
    since nextepc is not compatible with the vanilla upstream version
    - Add freeDiameter copyright info to debian/copyright
    - Update debian/README.source
    - Update debian/watch
  * debian/*.tmpfile
    - Create empty dirs in /var/run for all the executables using the systemd
      tmpfile mechanism
  * debian/*.service: Add systemd service files for all the 5 daemons
  * debian/control:
    - nextepc now "Architecture: all"
    - Some binaries only available on the same architectures where mongodb is
      available (Closes: #913460)
    - Moved most dependencies to recommends for "nextepc" binary package
    - Do not build-depend on libfreediameter-dev anymore
  * debian/config, debian/*.install:
    - Add a number of better default configuration files and install them

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 25 Nov 2018 07:58:28 +0100

nextepc (0.3.10+ds.1-1) unstable; urgency=medium

  * New upstream release

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 10 Nov 2018 20:06:17 +0000

nextepc (0.3.9+ds.1-2) unstable; urgency=medium

  * debian/copyright:
    - Added more copyright holders and licenses.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 06 Oct 2018 21:47:26 +0200

nextepc (0.3.9+ds.1-1) unstable; urgency=medium

  * Initial release. (Closes: #904218)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 01 Sep 2018 14:37:50 +0200

## nextepc 0.3.10+ds.1

=== debian/control ===
Source: nextepc
Maintainer: Debian Mobcom Maintainers <Debian-mobcom-maintainers@lists.alioth.debian.org>
Uploaders: Ruben Undheim <ruben.undheim@gmail.com>
Section: net
Priority: optional
Build-Depends: debhelper (>= 11),
               pkg-config,
               libsctp-dev,
               libyaml-dev,
               libmongoc-dev,
               libgcrypt-dev,
               flex,
               bison,
               libgnutls28-dev,
               libssl-dev,
               libidn11-dev,
               libbson-dev,
               libfreediameter-dev,
               txt2man
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/debian-mobcom-team/nextepc
Vcs-Git: https://salsa.debian.org/debian-mobcom-team/nextepc.git
Homepage: http://nextepc.org/

Package: nextepc-core
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Evolved Packet Core for LTE (Shared Files)
 NextEPC is a C-language Open Source implementation of the 3GPP Evolved
 Packet Core, i.e. the core network of an LTE network.
 .
 This package contains some core libraries/plugins required by the other
 binary packages such as nextepc-{mme,sgw,pgw,pcrf,hss}.

Package: nextepc-mme
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         nextepc-core (= ${binary:Version})
Description: Evolved Packet Core - Mobility Management Entity (MME)
 NextEPC is a C-language Open Source implementation of the 3GPP Evolved
 Packet Core, i.e. the core network of an LTE network.
 .
 This package provides the MME (Mobility Management Engine), which
 terminates the S1 interfaces from the eNodeBs cells in the cellular
 network, and interfaces via S11 to the SGW as well as via S6a to the
 HSS.

Package: nextepc-sgw
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         nextepc-core (= ${binary:Version})
Description: Evolved Packet Core - Serving Gateway (SGW)
 NextEPC is a C-language Open Source implementation of the 3GPP Evolved
 Packet Core, i.e. the core network of an LTE network.
 .
 This package provides the SGW (Serving Gateway) which is situated
 between the MME and PGW.  It implements the S11 interface to the MME,
 and the S5 interface to the PGW.

Package: nextepc-pgw
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         udev,
         nextepc-core (= ${binary:Version})
Description: Evolved Packet Core - Packet Data Network Gateway (PDN-GW)
 NextEPC is a C-language Open Source implementation of the 3GPP Evolved
 Packet Core, i.e. the core network of an LTE network.
 .
 This package provides the PGW or PDN-GW (Packet Data Network Gateway)
 element of the EPC, i.e. the gateway between the EPC and the external
 packet data network, such as the public Internet.  It implements the S5
 interface towards the S-GW, the SGi interface towards the Internet,
 and the S7 interface towards the PCRF.

Package: nextepc-pcrf
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mongodb,
         nextepc-core (= ${binary:Version})
Description: Evolved Packet Core - Policy and Charging Rules Function (PCRF)
 NextEPC is a C-language Open Source implementation of the 3GPP Evolved
 Packet Core, i.e. the core network of an LTE network.
 .
 This package contains the PCRF (Policy and Charging Rules Function),
 which controls the service quality (QoS) of individual connections and
 how to account/charge related traffic.  It implements the Gx interface
 towards the PGW using the DIAMETER protocol.

Package: nextepc-hss
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mongodb,
         nextepc-core (= ${binary:Version})
Description: Evolved Packet Core - Home Subscriber Server (HSS)
 NextEPC is a C-language Open Source implementation of the 3GPP Evolved
 Packet Core, i.e. the core network of an LTE network.
 .
 This package provides the HSS (Home Subscriber Server) element of the
 EPC, i.e. the central database of mobile network subscribers, with
 their IMSI, MSISDN, cryptographic key materials, service subscription
 information, etc.  It implements the S6a interface towards the MME
 using the DIAMETER protocol.

Package: nextepc
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         mongodb,
         nextepc-core (= ${binary:Version}),
         nextepc-mme (= ${binary:Version}),
         nextepc-sgw (= ${binary:Version}),
         nextepc-pgw (= ${binary:Version}),
         nextepc-hss (= ${binary:Version}),
         nextepc-pcrf (= ${binary:Version})
Description: Evolved Packet Core implementation for LTE (metapackage)
 NextEPC is a C-language Open Source implementation of the 3GPP Evolved
 Packet Core, i.e. the core network of an LTE network.
 .
 This is a metapackage that depends on all the nextepc parts.
 (MME, SGW, PGW, HSS, PCRF)

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%d %B %Y")

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with autoreconf

override_dh_auto_clean:
	dh_auto_clean
	$(RM) config.nice test/atconfig
	$(RM) debian/man/*.1

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	sctp_exclude_list="-x testsctp"; \
	lib/core/test/testcore $$sctp_exclude_list || exit
endif

override_dh_installman:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh
	dh_installman

# do not generate ldconfig trigger for nextepc-core
override_dh_makeshlibs:
	dh_makeshlibs -n

=== debian/watch ===
version=3
opts=dversionmangle=s/\+ds\.\d+//,\
oversionmangle=s/$/\+ds\.1/ \
https://github.com/acetcom/nextepc/releases /acetcom/nextepc/archive/v(\d\S+)\.tar\.(?:bz2|gz|xz)

## nextepc 0.3.10+nods

=== lib/freeDiameter-1.2.1/CMakeLists.txt ===
# This file is the source for generating the Makefile for the project, using cmake tool (cmake.org)

# Name of the project
PROJECT("freeDiameter")

# Informations to display in daemon's help
SET(FD_PROJECT_NAME freeDiameter)
SET(FD_PROJECT_BINARY freeDiameterd)
SET(FD_PROJECT_COPYRIGHT "Copyright (c) 2008-2015, WIDE Project (www.wide.ad.jp) and NICT (www.nict.go.jp)")

# Version of the source code
SET(FD_PROJECT_VERSION_MAJOR 1)
SET(FD_PROJECT_VERSION_MINOR 2)
SET(FD_PROJECT_VERSION_REV 1)

# Version of the API with the library
SET(FD_PROJECT_VERSION_API 6)

# The test framework, using CTest and CDash.
INCLUDE(CTest)

# CMake version
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

# Location of additional CMake modules
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

# The default directories
SET(DEFAULT_CONF_PATH ${CMAKE_INSTALL_PREFIX}/etc/freeDiameter CACHE PATH "Default location of freeDiameter configuration files")

IF (NOT DEFINED LIB_INSTALL_DIR)
SET(LIB_INSTALL_DIR lib CACHE PATH "Default library path name on the system, to accomodate RPM-based systems that use lib64")
ENDIF (NOT DEFINED LIB_INSTALL_DIR)

SET(INSTALL_HEADERS_SUFFIX 		include/freeDiameter 	CACHE PATH "Directory where the headers are installed (relative to CMAKE_INSTALL_PREFIX).")
SET(INSTALL_DAEMON_SUFFIX 		bin 			CACHE PATH "Directory where the daemon binary is installed (relative to CMAKE_INSTALL_PREFIX).")
SET(INSTALL_LIBRARY_SUFFIX 		${LIB_INSTALL_DIR} 			CACHE PATH "Directory where the freeDiameter libraries are installed (relative to CMAKE_INSTALL_PREFIX).")
SET(INSTALL_EXTENSIONS_SUFFIX 	${LIB_INSTALL_DIR}/freeDiameter	CACHE PATH "Directory where the extensions are installed / searched (relative to CMAKE_INSTALL_PREFIX).")

# All source code should be POSIX 200112L compatible, but some other extensions might be used, so:
ADD_DEFINITIONS(-D_GNU_SOURCE)

# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Debug' as none was specified.")
  set(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
    "MinSizeRel" "RelWithDebInfo" "Profiling" "MaxPerformance" "DebianPackage" "DebugValgrind")
endif()

# Add a "Profiling" build type
# SET(CMAKE_BUILD_TYPE Profiling)
SET(CMAKE_C_FLAGS_PROFILING "-fprofile-arcs -ftest-coverage -fstack-protector -g -Wall")

# Add a "MaxPerformance" build type -- this is very silent...
# SET(CMAKE_BUILD_TYPE MaxPerformance)
SET(CMAKE_C_FLAGS_MAXPERFORMANCE "${CMAKE_C_FLAGS_RELEASE} -DSTRIP_DEBUG_CODE")

# Add a "DebianPackage" build type used when creating the Debian packages
SET(CMAKE_C_FLAGS_DEBIANPACKAGE "${CMAKE_C_FLAGS_RELWITHDEBINFO}")

# Set the "Debug" flags
SET(CMAKE_C_FLAGS_DEBUG "-Wall -g -O0")

# Add a "DebugValgrind" build type used for checking execution with Valgrind tool
SET(CMAKE_C_FLAGS_DEBUGVALGRIND "-Wall -g -O0")

# Set the DEBUG flag for Debug and Profiling builds
IF (CMAKE_BUILD_TYPE MATCHES "Debug|Profiling|DebugValgrind")
  SET(DEBUG 1)
ENDIF (CMAKE_BUILD_TYPE MATCHES "Debug|Profiling|DebugValgrind")

# some subfolders use yacc and lex parsers
SET(BISON_GENERATE_DEFINES TRUE)
SET(BISON_PREFIX_OUTPUTS TRUE)
INCLUDE(CMakeUserUseBison)
SET(FLEX_PREFIX_OUTPUTS TRUE)
INCLUDE(CMakeUserUseFlex)
IF( NOT BISON_EXECUTABLE OR NOT FLEX_EXECUTABLE )
  MESSAGE( SEND_ERROR "Bison and Flex are required" )
ENDIF( NOT BISON_EXECUTABLE OR NOT FLEX_EXECUTABLE )
# Check that flex is at least 2.5.20 to support bison-bridge
# how to do the check with cmake???

# Add this to workaround an apparent bug in FreeBSD cmake (already defined in Linux)
SET(CMAKE_SHARED_LIBRARY_LINK_C_FLAGS "-rdynamic")

# For Darwin systems
IF(APPLE)
   SET(CMAKE_SHARED_MODULE_CREATE_C_FLAGS "${CMAKE_SHARED_MODULE_CREATE_C_FLAGS} -flat_namespace -undefined dynamic_lookup")
   SET(CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS "${CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS} -flat_namespace -undefined dynamic_lookup")
ENDIF(APPLE) 

# Location for the include files
INCLUDE_DIRECTORIES(include)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/include)
SUBDIRS(include/freeDiameter)

# Location for the source code
SUBDIRS(libfdproto)
SUBDIRS(libfdcore)
SUBDIRS(freeDiameterd)

# Extensions (there is no use of freeDiameter without any extension)
SUBDIRS(extensions)

# The unary tests directory
IF ( BUILD_TESTING )
	SUBDIRS(tests)
ENDIF ( BUILD_TESTING )

=== lib/freeDiameter-1.2.1/extensions/dict_dcca_3gpp/CMakeLists.txt ===
# The dict_dcca_3gpp extension
PROJECT("Diameter DCCA (Diameter Credit Control Application) 3GPP dictionary definitions" C)

# Compile as a module
FD_ADD_EXTENSION(dict_dcca_3gpp dict_dcca_3gpp.c)


####
## INSTALL section ##

INSTALL(TARGETS dict_dcca_3gpp
	LIBRARY DESTINATION ${INSTALL_EXTENSIONS_SUFFIX}
	COMPONENT freeDiameter-dictionary-rfc4006-extension-3gpp)

=== lib/freeDiameter-1.2.1/extensions/rt_ignore_dh/CMakeLists.txt ===
# The rt_ignore_dh extension
PROJECT("Routing extension that removes Destination-Host from messages and restores from Proxy-Info for answers" C)

# List of source files
SET(RT_IGNORE_DH_SRC
	rt_ignore_dh.c
)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

# Compile these files as a freeDiameter extension
FD_ADD_EXTENSION(rt_ignore_dh ${RT_IGNORE_DH_SRC})

####
## INSTALL section ##

# We install with the daemon component because it is a base feature.
INSTALL(TARGETS rt_ignore_dh
	LIBRARY DESTINATION ${INSTALL_EXTENSIONS_SUFFIX}
	COMPONENT freeDiameter-daemon)

=== lib/freeDiameter-1.2.1/include/freeDiameter/CMakeLists.txt ===
#CMake configuration for freeDiameter include directory

Project("freeDiameter includes directory" C)

########################
# Configurable parameters

# Disable SCTP support completely ?
OPTION(DISABLE_SCTP "Disable SCTP support?" OFF)
IF (NOT DISABLE_SCTP)
	OPTION(DEBUG_SCTP "Verbose SCTP (for debug)?" OFF)
	OPTION(SCTP_USE_MAPPED_ADDRESSES "Use v6-mapped v4 addresses in SCTP (workaround some SCTP limitations)?" OFF)
ENDIF (NOT DISABLE_SCTP)

# Find TODO items in the code easily ?
OPTION(ERRORS_ON_TODO "(development) Generate compilation errors on TODO items ?" OFF)

# In DEBUG mode, each log can contain pid, calling function and file for easy debug. Set to ON to display this information.
OPTION(DEBUG_WITH_META "Show calling location in logs?" OFF)
	
# Create the absolute path for searching extensions
SET(DEFAULT_EXTENSIONS_PATH ${CMAKE_INSTALL_PREFIX}/${INSTALL_EXTENSIONS_SUFFIX})

# IDNA considerations
OPTION(DIAMID_IDNA_IGNORE "Ignore completely invalid characters in Diameter Identities (process blindly)?" OFF)
IF (NOT DIAMID_IDNA_IGNORE)
	OPTION (DIAMID_IDNA_REJECT "Reject internationalized Diameter Identities, do not attempt to convert it (stringprep) ?" OFF)
ENDIF (NOT DIAMID_IDNA_IGNORE)

# Disable expiration of connections with dynamically connected peers as per RFC 3539 ? (default is enabled)
# Note: if someone needs, we could also make the delay configurable here...
OPTION(DISABLE_PEER_EXPIRY "Disable RFC3539 Peers Connections Expiration after inactivity?" OFF)

# The following workaround increases compatibility with some implementations without breaking anything in freeDiameter, 
# so it can be enabled without risk. We keep it disabled by default anyway for those people who use freeDiameter to check the 
# compliancy of their implementation with the Diameter RFC...
OPTION(WORKAROUND_ACCEPT_INVALID_VSAI "Do not reject a CER/CEA with a Vendor-Specific-Application-Id AVP containing both Auth- and Acct- application AVPs?" OFF)

MARK_AS_ADVANCED(DISABLE_SCTP DEBUG_SCTP SCTP_USE_MAPPED_ADDRESSES ERRORS_ON_TODO DEBUG_WITH_META DIAMID_IDNA_IGNORE DIAMID_IDNA_REJECT DISABLE_PEER_EXPIRY WORKAROUND_ACCEPT_INVALID_VSAI)

########################
### System checks part

INCLUDE (CheckLibraryExists)
INCLUDE (CheckFunctionExists)
INCLUDE (CheckIncludeFiles)
INCLUDE (CheckSymbolExists) 
INCLUDE (CheckCSourceCompiles)
INCLUDE (TestBigEndian)


### System checks -- mandatory support

# We need the getopt_long function
CHECK_FUNCTION_EXISTS (getopt_long HAVE_LONG_OPTIONS)
IF (NOT HAVE_LONG_OPTIONS)
   MESSAGE(SEND_ERROR "The getopt_long function is not found, please add needed library in build system")
ENDIF (NOT HAVE_LONG_OPTIONS)

# getifaddrs ?
CHECK_FUNCTION_EXISTS (getifaddrs HAVE_GETIFADDRS)
IF (NOT HAVE_GETIFADDRS)
   MESSAGE(SEND_ERROR "The getifaddrs function is currently required by freeDiameter.")
ENDIF (NOT HAVE_GETIFADDRS)


### System checks -- for freeDiameter-host.h

# Check byte ordering
TEST_BIG_ENDIAN(HOST_BIG_ENDIAN)

# Check if ntohll is provided on the system
CHECK_SYMBOL_EXISTS(ntohll netinet/in.h HAVE_NTOHLL)

# malloc.h ?
CHECK_INCLUDE_FILES (malloc.h HAVE_MALLOC_H)

# strndup ? Missing on OS X
CHECK_FUNCTION_EXISTS (strndup HAVE_STRNDUP)


### System checks -- for includes / link

# pthreads
INCLUDE(FindThreads)
SET(CMAKE_THREAD_LIBS_INIT ${CMAKE_THREAD_LIBS_INIT} PARENT_SCOPE)

# clock_gettime
SET(HAVE_CLOCK_GETTIME "")
CHECK_FUNCTION_EXISTS (clock_gettime HAVE_NATIVE_CLOCK_GETTIME)
IF (HAVE_NATIVE_CLOCK_GETTIME)
   SET(CLOCK_GETTIME_LIBS "")
   SET(HAVE_CLOCK_GETTIME 1)
ELSE (HAVE_NATIVE_CLOCK_GETTIME)
   CHECK_LIBRARY_EXISTS (rt clock_gettime "" HAVE_LIBRT)
   IF (HAVE_LIBRT)
     SET(CLOCK_GETTIME_LIBS "-lrt")
     SET(HAVE_CLOCK_GETTIME 1)
   ELSE (HAVE_LIBRT)
     CHECK_LIBRARY_EXISTS (posix4 clock_gettime "" HAVE_LIBPOSIX4)
     IF (HAVE_LIBPOSIX4)
       SET(CLOCK_GETTIME_LIBS "-lposix4")
       SET(HAVE_CLOCK_GETTIME 1)
     ENDIF (HAVE_LIBPOSIX4)
   ENDIF (HAVE_LIBRT)
ENDIF (HAVE_NATIVE_CLOCK_GETTIME)
SET(CLOCK_GETTIME_LIBS ${CLOCK_GETTIME_LIBS} PARENT_SCOPE)

# dlopen and dlclose: CMAKE_DL_LIBS

# We need the sctp_connectx function among others
# We need the IPPROTO_SCTP symbol from sys/socket.h, netinet/in.h or netinet/sctp.h
IF(NOT DISABLE_SCTP)
	CHECK_FUNCTION_EXISTS(sctp_connectx HAVE_NATIVE_SCTP)
	IF(NOT HAVE_NATIVE_SCTP)
		FIND_PACKAGE(SCTP REQUIRED)
	ENDIF(NOT HAVE_NATIVE_SCTP)
	# Now check the number of args of this function, since it changed between Ubuntu 9.04 and 9.10
   	SET(CHECK_SCTP_CONNECTX_4_ARGS_SOURCE_CODE "
		#include <unistd.h>
		#include <netinet/sctp.h>
		int main() {
		   return sctp_connectx(0, NULL, 0, NULL);
		}
		")
	SET(CMAKE_REQUIRED_INCLUDES ${SCTP_INCLUDE_DIR})
	SET(CMAKE_REQUIRED_LIBRARIES ${SCTP_LIBRARIES})
	CHECK_C_SOURCE_COMPILES("${CHECK_SCTP_CONNECTX_4_ARGS_SOURCE_CODE}" SCTP_CONNECTX_4_ARGS)
ELSE (NOT DISABLE_SCTP)
	MESSAGE(STATUS "Disabled SCTP support.")
ENDIF(NOT DISABLE_SCTP)
SET(SCTP_INCLUDE_DIR ${SCTP_INCLUDE_DIR} PARENT_SCOPE)
SET(SCTP_LIBRARIES ${SCTP_LIBRARIES} PARENT_SCOPE)

# IDNA process: we use libidn from GNU (unless the function & header files are included in libc)
IF(NOT DIAMID_IDNA_IGNORE  AND NOT DIAMID_IDNA_REJECT)
	FIND_PACKAGE(IDNA)
   	SET(CHECK_IDNA_SOURCE_CODE "
		#include <idna.h>
		int main() {
		   return idna_to_ascii_8z(NULL, NULL, 0);
		}
		")
	SET(CMAKE_REQUIRED_INCLUDES ${IDNA_INCLUDE_DIR})
	SET(CMAKE_REQUIRED_LIBRARIES ${IDNA_LIBRARIES})
	CHECK_C_SOURCE_COMPILES("${CHECK_IDNA_SOURCE_CODE}" HAS_IDNA_SUPPORT)
	IF(NOT HAS_IDNA_SUPPORT)
		MESSAGE(SEND_ERROR "Unable to find idna.h header or idna_to_ascii_8z function, please install libidn-dev or equivalent, or set DIAMID_IDNA_IGNORE or DIAMID_IDNA_REJECT")
	ENDIF(NOT HAS_IDNA_SUPPORT)
ELSE (NOT DIAMID_IDNA_IGNORE  AND NOT DIAMID_IDNA_REJECT)
	MESSAGE(STATUS "Non-default Internationalized Domain Names (IDN) behavior selected (no stringprep).")
ENDIF(NOT DIAMID_IDNA_IGNORE  AND NOT DIAMID_IDNA_REJECT)
SET(IDNA_INCLUDE_DIR ${IDNA_INCLUDE_DIR} PARENT_SCOPE)
SET(IDNA_LIBRARIES ${IDNA_LIBRARIES} PARENT_SCOPE)


# Require GNU TLS for building the library
FIND_PACKAGE(GnuTLS REQUIRED)
SET(GNUTLS_INCLUDE_DIR ${GNUTLS_INCLUDE_DIR} PARENT_SCOPE)
SET(GNUTLS_LIBRARIES ${GNUTLS_LIBRARIES} PARENT_SCOPE)

find_path(GCRYPT_INCLUDE_DIR NAMES gcrypt.h)
If ( NOT GCRYPT_INCLUDE_DIR )
	MESSAGE(SEND_ERROR "Unable to find gcrypt.h, please install libgcrypt-dev or equivalent")
Endif ( NOT GCRYPT_INCLUDE_DIR )
MARK_AS_ADVANCED(GCRYPT_INCLUDE_DIR)
SET(GCRYPT_INCLUDE_DIR ${GCRYPT_INCLUDE_DIR} PARENT_SCOPE)

# Also we need libgcrypt to... display its version :(
find_library(GCRYPT_LIBRARY 
  NAMES gcrypt
)
If ( NOT GCRYPT_LIBRARY )
	MESSAGE(SEND_ERROR "Unable to find libgcrypt, please install libgcrypt or equivalent")
Endif ( NOT GCRYPT_LIBRARY )
SET(GCRYPT_LIBRARY ${GCRYPT_LIBRARY} PARENT_SCOPE)


# Check if AI_ADDRCONFIG is available on the system
CHECK_SYMBOL_EXISTS(AI_ADDRCONFIG "netdb.h" HAVE_AI_ADDRCONFIG)


# Check if barriers are available (for test_fifo)
SET(CMAKE_REQUIRED_INCLUDES "pthread.h")
SET(CMAKE_REQUIRED_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
CHECK_FUNCTION_EXISTS (pthread_barrier_wait HAVE_PTHREAD_BAR)
SET(HAVE_PTHREAD_BAR ${HAVE_PTHREAD_BAR} PARENT_SCOPE)


##########################

# Additional hg version when relevant, stored in version.h
if (EXISTS "${CMAKE_SOURCE_DIR}/.hg")
	# Search for hg binary to use
	FIND_PROGRAM(HGCOMMAND hg)
	if (HGCOMMAND)
		# Ok, add the custom target so that hg is executed at every build
		ADD_CUSTOM_TARGET(version_information
				   COMMAND ${CMAKE_COMMAND} -D HGCOMMAND="${HGCOMMAND}" -D SRC="${CMAKE_CURRENT_SOURCE_DIR}/version.h.in" -D DST="${CMAKE_CURRENT_BINARY_DIR}/version.h" -P "${CMAKE_SOURCE_DIR}/cmake/Modules/GetVersionWithHg.cmake"
				   DEPENDS "${CMAKE_SOURCE_DIR}/.hg/dirstate"
				   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
				   COMMENT "Retrieving version of the hg repository"
				   )
	else (HGCOMMAND)
		# Display at least "unknown" rev in this case
		SET(FD_PROJECT_VERSION_HG "unknown")
		CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/version.h)
		ADD_CUSTOM_TARGET(version_information DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/version.h)
	endif(HGCOMMAND)
else (EXISTS "${CMAKE_SOURCE_DIR}/.hg")
	# We use the pure version number without extension
	CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/version.h)
	ADD_CUSTOM_TARGET(version_information DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/version.h)
endif (EXISTS "${CMAKE_SOURCE_DIR}/.hg")


##########################

# LFDPROTO_LIBS = libraries required by the libfdproto.
SET(LFDPROTO_LIBS ${CLOCK_GETTIME_LIBS} ${CMAKE_THREAD_LIBS_INIT} ${IDNA_LIBRARIES} PARENT_SCOPE)
# And includes paths
SET(LFDPROTO_INCLUDES ${IDNA_INCLUDE_DIR} PARENT_SCOPE)
# Dependencies: the libraries required by any code linking to libfdproto.
SET(LFDPROTO_LINK_INTERFACES ${CMAKE_THREAD_LIBS_INIT} PARENT_SCOPE)

# LFDCORE_LIBS = libraries required by the libfdcore (in addition to libfdproto and its dependencies)
SET(LFDCORE_LIBS ${CLOCK_GETTIME_LIBS} ${CMAKE_DL_LIBS} ${SCTP_LIBRARIES} ${GCRYPT_LIBRARY} ${GNUTLS_LIBRARIES} PARENT_SCOPE)
# And includes paths
SET(LFDCORE_INCLUDES ${SCTP_INCLUDE_DIR} ${GNUTLS_INCLUDE_DIR} ${GCRYPT_INCLUDE_DIR} PARENT_SCOPE)
# And dependencies
SET(LFDCORE_LINK_INTERFACES "" PARENT_SCOPE) 
		# We don't force other libraries, the programs will link with what it needs
                # (such as libgnutls if it uses GNUTLS_DEBUG() macro
		# or libfdproto if it uses some of its interfaces directly)
		# See freeDiameterd/CMakeLists.txt for an example.

##########################

# Generate the host.h file
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/freeDiameter-host.h.in ${CMAKE_CURRENT_BINARY_DIR}/freeDiameter-host.h)

####
## INSTALL section ##

# The headers from this directory are required to develop new extensions for freeDiameter.
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/freeDiameter-host.h libfdproto.h libfdcore.h extension.h
	DESTINATION ${INSTALL_HEADERS_SUFFIX}
	COMPONENT freeDiameter-dev)

=== debian/control ===
--- 
+++ 
@@ -15,9 +15,8 @@
                libssl-dev,
                libidn11-dev,
                libbson-dev,
-               libfreediameter-dev,
                txt2man
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Vcs-Browser: https://salsa.debian.org/debian-mobcom-team/nextepc
 Vcs-Git: https://salsa.debian.org/debian-mobcom-team/nextepc.git
 Homepage: http://nextepc.org/
@@ -77,11 +76,11 @@
  and the S7 interface towards the PCRF.
 
 Package: nextepc-pcrf
-Architecture: any
+Architecture: amd64 arm64 ppc64el s390x
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         mongodb,
          nextepc-core (= ${binary:Version})
+Recommends: mongodb
 Description: Evolved Packet Core - Policy and Charging Rules Function (PCRF)
  NextEPC is a C-language Open Source implementation of the 3GPP Evolved
  Packet Core, i.e. the core network of an LTE network.
@@ -92,11 +91,11 @@
  towards the PGW using the DIAMETER protocol.
 
 Package: nextepc-hss
-Architecture: any
+Architecture: amd64 arm64 ppc64el s390x
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         mongodb,
          nextepc-core (= ${binary:Version})
+Recommends: mongodb
 Description: Evolved Packet Core - Home Subscriber Server (HSS)
  NextEPC is a C-language Open Source implementation of the 3GPP Evolved
  Packet Core, i.e. the core network of an LTE network.
@@ -108,16 +107,16 @@
  using the DIAMETER protocol.
 
 Package: nextepc
-Architecture: any
+Architecture: all
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         mongodb,
-         nextepc-core (= ${binary:Version}),
-         nextepc-mme (= ${binary:Version}),
-         nextepc-sgw (= ${binary:Version}),
-         nextepc-pgw (= ${binary:Version}),
-         nextepc-hss (= ${binary:Version}),
-         nextepc-pcrf (= ${binary:Version})
+         nextepc-core (>= ${source:Version}), nextepc-core (<< ${source:Upstream-Version}.0~),
+         nextepc-mme  (>= ${source:Version}), nextepc-mme  (<< ${source:Upstream-Version}.0~),
+         nextepc-pgw  (>= ${source:Version}), nextepc-pgw  (<< ${source:Upstream-Version}.0~),
+         nextepc-sgw  (>= ${source:Version}), nextepc-sgw  (<< ${source:Upstream-Version}.0~),
+         nextepc-pcrf (>= ${source:Version}), nextepc-pcrf (<< ${source:Upstream-Version}.0~),
+         nextepc-hss  (>= ${source:Version}), nextepc-hss  (<< ${source:Upstream-Version}.0~)
+Recommends: mongodb
 Description: Evolved Packet Core implementation for LTE (metapackage)
  NextEPC is a C-language Open Source implementation of the 3GPP Evolved
  Packet Core, i.e. the core network of an LTE network.

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,8 @@
 include /usr/share/dpkg/pkg-info.mk
 
 CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%d %B %Y")
+
+multiarch = $(shell dpkg-architecture -qDEB_BUILD_MULTIARCH)
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
@@ -31,3 +33,11 @@
 # do not generate ldconfig trigger for nextepc-core
 override_dh_makeshlibs:
 	dh_makeshlibs -n
+
+override_dh_installsystemd:
+	dh_installsystemd --no-enable --no-start
+
+override_dh_auto_install:
+	dh_auto_install
+	$(RM) debian/tmp/usr/lib/nextepc/freeDiameter/*.la
+	$(RM) debian/tmp/usr/lib/nextepc/*.la

=== debian/tests/control ===
Tests: nextepc-mmed-help, nextepc-pgwd-help, nextepc-sgwd-help
Depends: nextepc
